LeetCode:Nim Game

先上题目链接:Nim Game

You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.

题目大意就是给你一堆石头,每次可以从中拿出1~3块,两个人轮流拿,拿到最后一块石头的人获胜。现在有 n 块石头,由你先拿,请快速判断你能否获胜。

f(n) 表示有 n 块石头时的获胜情况(必输/必赢),由于你拿了之后,接着是对方拿,所以得到公式:

f(n)=![f(n1)&&f(n2)&&f(n3)]

由于 f(1)=f(2)=f(3)=true,结合公式可以发现这是一个长度为4的循环,得到这样一个关系:
f(n)={false,true,if n mod 4 is zeroother conditions

代码如下:

public class Solution {
    public boolean canWinNim(int n) {
        boolean result = false;
        if (n < 1) {
            return false;
        } 

        if ((n%4) != 0) {
            result = true;
        }

        return result;
    }
}



我的作业部落链接:Nim Game

原文地址:https://www.cnblogs.com/read-the-spring-and-autumn-annals-in-night/p/12041940.html